unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls,
  ShellAPI, ShlObj, urls, SUIListView, SUIButton, SUIListBox,
  SUIImagePanel, SUIGroupBox, SUIForm, ImgList;

type
  TMainForm = class(TForm)
    bvlSessions: TBevel;
    bvlTopSessions: TBevel;
    plButtonFiles: TPanel;
    bvlLeftFiles: TBevel;
    plFiles: TPanel;
    bvlTopFiles: TBevel;
    bvlTraffic: TBevel;
    tmrTraffic: TTimer;
    Url1: TUrl;
    suiForm1: TsuiForm;
    gbxShares: TsuiGroupBox;
    lbxShares: TsuiListBox;
    btnGetShares: TsuiButton;
    btnCloseShares: TsuiButton;
    btnAddShares: TsuiButton;
    gbxSessions: TsuiGroupBox;
    lvSessions: TsuiListView;
    btnCloseSession: TsuiButton;
    btnGetSessions: TsuiButton;
    Button1: TsuiButton;
    Button2: TsuiButton;
    gbxFiles: TsuiGroupBox;
    btnGetFiles: TsuiButton;
    btnCloseFile: TsuiButton;
    lvFiles: TsuiListView;
    gbxTraffic: TsuiGroupBox;
    lvTraffic: TsuiListView;
    ImageList1: TImageList;
    function  IsNT(var Value: Boolean): Boolean;
    procedure suitempbtnGetSharesClick(Sender: TObject);
    procedure suitempbtnCloseSharesClick(Sender: TObject);
    function  SelectDirectory: String;
    procedure suitempbtnAddSharesClick(Sender: TObject);
    function  CardinalToTimeStr(Value:Cardinal):String;
    procedure suitempbtnGetSessionsClick(Sender: TObject);
    procedure suitempbtnCloseSessionClick(Sender: TObject);
    procedure suitempbtnGetFilesClick(Sender: TObject);
    procedure suitempbtnCloseFileClick(Sender: TObject);
    procedure tmrTrafficTimer(Sender: TObject);
    procedure suitempButton1Click(Sender: TObject);
    procedure suitempButton2Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    SessionCloseKey: array [0..512] of SmallInt;
  end;

type
 TShareInfo2 = packed record
  shi2_netname : PWChar;
  shi2_type: DWORD;
  shi2_remark :PWChar;
  shi2_permissions: DWORD;
  shi2_max_uses : DWORD;
  shi2_current_uses : DWORD;
  shi2_path : PWChar;
  shi2_passwd : PWChar;
 end;
 PShareInfo2 = ^ TShareInfo2;
 TShareInfo2Array = array [0..512] of TShareInfo2;
 PShareInfo2Array = ^ TShareInfo2Array;

type
 TShareInfo50 = packed record
  shi50_netname : array [0..12] of Char;
  shi50_type : Byte;
  shi50_flags : Word;
  shi50_remark : PChar;
  shi50_path : PChar;
  shi50_rw_password : array [0..8] of Char;
  shi50_ro_password : array [0..8] of Char;
 end;

type 
 TSessionInfo502 = packed record
   Sesi502_cname: PWideChar;
   Sesi502_username: PWideChar;
   Sesi502_num_opens: DWORD;
   Sesi502_time: DWORD;
   Sesi502_idle_time: DWORD;
   Sesi502_user_flags: DWORD;
   Sesi502_cltype_name: PWideChar;
   Sesi502_transport: PWideChar;
 End;
 PSessionInfo502 = ^TSessionInfo502;
 TSessionInfo502Array = array[0..512] of TSessionInfo502;
 PSessionInfo502Array = ^TSessionInfo502Array;

type 
 TSessionInfo50 = packed record
   Sesi50_cname       : PChar;
   Sesi50_username    : PChar;
   sesi50_key         : Cardinal;
   sesi50_num_conns   : Word;
   sesi50_num_opens   : Word;
   sesi50_time        : Cardinal;
   sesi50_idle_time   : Cardinal;
   sesi50_protocol    : Byte;
   pad1               : Byte;
 end;

type
 TFileInfo3 = packed record
   fi3_id          : DWORD;
   fi3_permissions : DWORD;
   fi3_num_locks   : DWORD;
   fi3_pathname    : PWChar;
   fi3_username    : PWChar;
 end;
 PFileInfo3 = ^TFileInfo3;
 TFileInfo3Array = array[0..512] of TFileInfo3;
 PFileInfo3Array = ^TFileInfo3Array;

type
 TFileInfo50 = packed record
   fi50_id          : Cardinal;
   fi50_permissions : WORD;
   fi50_num_locks   : WORD;
   fi50_pathname    : PChar;
   fi50_username    : PChar;
   fi50_sharename   : PChar;
 end;

type
  TMibIfRow = packed record
    wszName            : array[0..255] of WideChar;
    dwIndex            : DWORD;
    dwType             : DWORD;
    dwMtu              : DWORD;
    dwSpeed            : DWORD;
    dwPhysAddrLen      : DWORD;
    bPhysAddr          : array[0..7] of Byte;
    dwAdminStatus      : DWORD;
    dwOperStatus       : DWORD;
    dwLastChange       : DWORD;
    dwInOctets         : DWORD;
    dwInUcastPkts      : DWORD;
    dwInNUCastPkts     : DWORD;
    dwInDiscards       : DWORD;
    dwInErrors         : DWORD;
    dwInUnknownProtos  : DWORD;
    dwOutOctets        : DWORD;
    dwOutUCastPkts     : DWORD;
    dwOutNUCastPkts    : DWORD;
    dwOutDiscards      : DWORD;
    dwOutErrors        : DWORD;
    dwOutQLen          : DWORD;
    dwDescrLen         : DWORD;
    bDescr             : array[0..255] of Char; 
  end;
  TMibIfArray = array [0..512] of TMibIfRow;
  PMibIfRow = ^TMibIfRow;
  PMibIfArray = ^TMibIfArray;

type
 TMibIfTable = packed record
   dwNumEntries     : DWORD;
   Table            : TMibIfArray;
 end;
 PMibIfTable = ^TMibIfTable;



var
NetShareEnumNT:function (	servername:PWChar; 
                          level:DWORD;
                          bufptr:Pointer;
                          prefmaxlen:DWORD;
                          entriesread,
                          totalentries,
                          resume_handle:LPDWORD): DWORD; stdcall;

var
NetShareEnum:function (	pszServer	: PChar;
                        sLevel		: Cardinal;
                        pbBuffer	: Pchar;
                        cbBuffer	: Cardinal;
                        pcEntriesRead,
                        pcTotalAvail: Pointer):DWORD; stdcall;

var
NetShareDelNT:function (servername: PWideChar;
                        netname: PWideChar;
                        reserved: DWORD): LongInt; stdcall;

var
NetShareDel:function (  pszServer,
                        pszNetName:PChar;
                        usReserved:Word): DWORD; stdcall;

var
NetShareAddNT: function(servername: PWideChar;
                        level: DWORD;
                        buf: Pointer;
                        parm_err: LPDWORD): DWORD; stdcall;
             
var
NetShareAdd: function (	pszServer:Pchar;
                        sLevel:Cardinal;
                        pbBuffer:PChar;
                        cbBuffer:Word):DWORD; stdcall;

Var
NetSessionEnumNT:function(servername,
                        UncClientName,
                        username:PWChar;
                        level:DWORD;
                        bufptr:Pointer;
                        prefmaxlen:DWORD;
                        entriesread,
                        totalentries,
                        resume_handle:LPDWORD):DWORD; stdcall;

var
NetSessionEnum:function(pszServer:PChar;
                        sLevel: DWORD;
                        pbBuffer:Pointer;
                        cbBuffer:DWORD;
                        pcEntriesRead,
                        pcTotalAvial:Pointer):integer; stdcall;

var
NetSessionDelNT:function(ServerName,
                        UncClientName,
                        username:PWChar):DWORD; stdcall;

var
NetSessionDel:function( pszServer:PChar;
                        pszClientName: PChar;
                        sReserved: SmallInt):DWORD; stdcall;

var
NetFileEnumNT:function(	servername,
                        basepath,
                        username:PWChar;
                        level:DWORD;
                        bufptr:Pointer;
                        prefmaxlen:DWORD;
                        entriesread,
                        totalentries,
                        resume_handle:LPDWORD):DWORD; stdcall;

var
NetFileEnum:function(	  pszServer,
                        pszBasePath:PChar;
                        sLevel:DWORD;
                        pbBuffer:Pointer;
                        cbBuffer:DWORD;
                        pcEntriesRead,
                        pcTotalAvail:pointer):integer; stdcall;

var
NetFileClose:function(	ServerName:PWideChar;
                        FileId:DWORD):DWORD; stdcall;

var
NetFileClose2:function(	pszServer:PChar;
                        ulFileId:LongWord):DWORD; stdcall;

var
GetIfTable:function(    pIfTable    : PMibIfTable;
                        pdwSize     : PULONG;
                        bOrder      : Boolean ): DWORD; stdcall;

var
  MainForm: TMainForm;
  torefresh:boolean;

implementation

{$R *.dfm}

{ TMainForm }

////////////////////////////////////////////////////////////////////////////////
//
//     ,     ,
//      ( NT  )    .
//     ,      .
//

function TMainForm.IsNT(var Value: Boolean): Boolean;
var Ver: TOSVersionInfo;
    BRes: Boolean;
begin
  Ver.dwOSVersionInfoSize := SizeOf(TOSVersionInfo);
  BRes := GetVersionEx(Ver);
  if not BRes then   //
  begin
    Result := False; //  
    Exit;            //
  end else
    Result := True;  // 

  case Ver.dwPlatformId of //
    VER_PLATFORM_WIN32_NT       : Value := True;  //Windows NT - 
    VER_PLATFORM_WIN32_WINDOWS  : Value := False; //Windows 9x-Me - 
    VER_PLATFORM_WIN32s         : Result := False //Windows 3.x -  
  end;
end;

////////////////////////////////////////////////////////////////////////////////
//
//      
//

procedure TMainForm.suitempbtnGetSharesClick(Sender: TObject);
var
  i:Integer;
  FLibHandle : THandle;
  ShareNT : PShareInfo2Array;     //<= 
  entriesread,totalentries:DWORD; //<=  Windows NT
  Share : array [0..512] of TShareInfo50; //<= 
  pcEntriesRead,pcTotalAvail:Word;        //<=  Windows 9x-Me
  OS: Boolean;
begin
  lbxShares.Items.Clear;
  if not IsNT(OS) then Close; //  

  if OS then begin  //  NT
    FLibHandle := LoadLibrary('NETAPI32.DLL'); // 
    if FLibHandle = 0 then Exit;
    // 
    @NetShareEnumNT := GetProcAddress(FLibHandle,'NetShareEnum');
    if not Assigned(NetShareEnumNT) then //
    begin
      FreeLibrary(FLibHandle);
      Exit;
    end;
    ShareNT := nil; //    
    // 
    if NetShareEnumNT(nil,2,@ShareNT,DWORD(-1),
                      @entriesread,@totalentries,nil) <> 0 then
    begin  //    
      FreeLibrary(FLibHandle);
      Exit;
    end;
    if entriesread > 0 then // 
    for i:= 0 to entriesread - 1 do
      lbxShares.Items.Add(String(ShareNT^[i].shi2_netname));
  end else begin //  9-
    FLibHandle := LoadLibrary('SVRAPI.DLL'); // 
    if FLibHandle = 0 then Exit;
    // 
    @NetShareEnum := GetProcAddress(FLibHandle,'NetShareEnum');
    if not Assigned(NetShareEnum) then //
    begin
      FreeLibrary(FLibHandle);
      Exit;
    end;
    // 
    if NetShareEnum(nil,50,@Share,SizeOf(Share),
                 @pcEntriesRead,@pcTotalAvail)<> 0 then
    begin  //    
      FreeLibrary(FLibHandle);
      Exit;
    end;
    if pcEntriesRead > 0 then // 
    for i:= 0 to pcEntriesRead - 1 do
      lbxShares.Items.Add(String(Share[i].shi50_netname));
  end;
  FreeLibrary(FLibHandle); //   
end;

////////////////////////////////////////////////////////////////////////////////
//
//    
//

procedure TMainForm.suitempbtnCloseSharesClick(Sender: TObject);
var
  OS:Boolean;
  FLibHandle : THandle;
  Name9x:array [0..12] of Char;
  NameNT:PWChar;
  i:Integer;
  ShareName: String;
begin
  if not IsNT(OS) then Close; //  

  if lbxShares.Items.Count = 0 then Exit;
  for i:= 0 to lbxShares.Items.Count -1 do
    if lbxShares.Selected[i] then Break;  //  
  if not lbxShares.Selected[i] then Exit; //   
  ShareName := lbxShares.Items.Strings[i];

  if OS then begin //  NT
    FLibHandle := LoadLibrary('NETAPI32.DLL');
    if FLibHandle = 0 then Exit;
    @NetShareDelNT := GetProcAddress(FLibHandle,'NetShareDel');
    if not Assigned(NetShareDelNT) then //
    begin
      FreeLibrary(FLibHandle);
      Exit;
    end;
    i:= SizeOf(WideChar)*256;
    GetMem(NameNT,i);  //   
    StringToWideChar(ShareName,NameNT,i); //  PWideChar
    NetShareDelNT(nil,NameNT,0);   // 
    FreeMem(NameNT);  // 
  end else begin  //  9-
    FLibHandle := LoadLibrary('SVRAPI.DLL');
    if FLibHandle = 0 then Exit;
    @NetShareDel := GetProcAddress(FLibHandle,'NetShareDel');
    if not Assigned(NetShareDel) then //
    begin
      FreeLibrary(FLibHandle);
      Exit;
    end;
    FillChar(Name9x, SizeOf(Name9x), #0); // 
    move(ShareName[1],Name9x[0],Length(ShareName)); // 
    NetShareDel(nil,@Name9x,0); // 
  end;
  FreeLibrary(FLibHandle);
end;

////////////////////////////////////////////////////////////////////////////////
//
//     
//

function TMainForm.SelectDirectory: String;
var
  lpItemID : PItemIDList;
  BrowseInfo : TBrowseInfo;
  DisplayName : array[0..MAX_PATH] of Char;
  TempPath : array[0..MAX_PATH] of Char;
begin
  FillChar(BrowseInfo, sizeof(TBrowseInfo), #0);
  BrowseInfo.hwndOwner := Handle;
  BrowseInfo.pszDisplayName := @DisplayName;
  BrowseInfo.lpszTitle := 'Specify a directory';
  BrowseInfo.ulFlags := BIF_RETURNONLYFSDIRS;
  lpItemID := SHBrowseForFolder(BrowseInfo);
  if Assigned(lpItemId) then begin
    SHGetPathFromIDList(lpItemID, TempPath);
    GlobalFreePtr(lpItemID);
  end else Result := '';
  Result := String(TempPath);
end;

////////////////////////////////////////////////////////////////////////////////
//
//    
//

procedure TMainForm.suitempbtnAddSharesClick(Sender: TObject);
const
  STYPE_DISKTREE = 0;
  ACCESS_ALL =  258;
  SHI50F_FULL = 258;
var
  FLibHandle : THandle;
  Share9x : TShareInfo50;
  ShareNT : TShareInfo2;
  TmpDir, TmpName: String;
  TmpDirNT, TmpNameNT: PWChar;
  OS: Boolean;
  TmpLength: Integer;
begin
  TmpDir := SelectDirectory; //    
  if TmpDir <> '' then TmpName := InputBox(' ','','Test') //        
  else Exit;


  if not IsNT(OS) then Close; //  

  if OS then begin //  NT
    FLibHandle := LoadLibrary('NETAPI32.DLL');
    if FLibHandle = 0 then Exit;
    @NetShareAddNT := GetProcAddress(FLibHandle,'NetShareAdd');
    if not Assigned(NetShareAddNT) then
    begin
      FreeLibrary(FLibHandle);
      Exit;
    end;
    TmpLength := SizeOF(WideChar)*256; //  
    
    GetMem(TmpNameNT, TmpLength); //  PWChar
    StringToWideChar(TmpName, TmpNameNT, TmpLength);
    ShareNT.shi2_netname := TmpNameNT; //

    ShareNT.shi2_type := STYPE_DISKTREE; // 
    ShareNT.shi2_remark := ''; //
    ShareNT.shi2_permissions := ACCESS_ALL; //
    ShareNT.shi2_max_uses := DWORD(-1); //- . .
    ShareNT.shi2_current_uses := 0; //-  .

    GetMem(TmpDirNT, TmpLength);
    StringToWideChar(TmpDir, TmpDirNT, TmpLength);
    ShareNT.shi2_path := TmpDirNT; //  

    ShareNT.shi2_passwd := ''; //

    NetShareAddNT(nil,2,@ShareNT, nil); // 
    FreeMem (TmpNameNT); // 
    FreeMem (TmpDirNT);
  end else begin
    FLibHandle := LoadLibrary('SVRAPI.DLL');
    if FLibHandle = 0 then Exit;
    @NetShareAdd := GetProcAddress(FLibHandle,'NetShareAdd');
    if not Assigned(NetShareAdd) then
    begin
      FreeLibrary(FLibHandle);
      Exit;
    end;
    FillChar(Share9x.shi50_netname, SizeOf(Share9x.shi50_netname), #0);
    move(TmpName[1],Share9x.shi50_netname[0],Length(TmpName)); //
    Share9x.shi50_type := STYPE_DISKTREE; // 
    Share9x.shi50_flags := SHI50F_FULL; //
    FillChar(Share9x.shi50_remark,
      SizeOf(Share9x.shi50_remark), #0); //
    FillChar(Share9x.shi50_path,
      SizeOf(Share9x.shi50_path), #0);
    Share9x.shi50_path := PAnsiChar(TmpDir); //  
    FillChar(Share9x.shi50_rw_password,
      SizeOf(Share9x.shi50_rw_password), #0); //  
    FillChar(Share9x.shi50_ro_password,
      SizeOf(Share9x.shi50_ro_password), #0); //  
    NetShareAdd(nil,50,@Share9x,SizeOf(Share9x));
  end;
  FreeLibrary(FLibHandle);
end;

////////////////////////////////////////////////////////////////////////////////
//
//           
//    -  ( Cardinal).   
//  ,     -   
//    .
//

function TMainForm.CardinalToTimeStr(Value: Cardinal): String;
var d,h,m,s: Real;
begin
    d:=0;
    h:=0;
    m:=0;
    s:=Value;
    if s > 59 then begin
        m:=int(s / 60);
        s:=s-(m*60);
    end;
    if m > 59 then begin
        h:=int(m/60);
        m:=m-(h*60);
    end;
    if h > 23 then begin
        d:=int(h/24);
        h:=h-(d*24);
    end;
    Result:='';
    if (d>0) then Result:=Result+floattostr(d)+' d. ';
    if (h<9) then Result:=Result+'0'+floattostr(h)+':' else Result:=Result+floattostr(h)+':';
    if (m<9) then Result:=Result+'0'+floattostr(m)+':' else Result:=Result+floattostr(m)+':';
    if (s<9) then Result:=Result+'0'+floattostr(s)     else Result:=Result+floattostr(s);
end;

////////////////////////////////////////////////////////////////////////////////
//
//    
//

procedure TMainForm.suitempbtnGetSessionsClick(Sender: TObject);
var
  OS: Boolean;
  FLibHandle : THandle;
  SessionInfo50: array [0..512] of TSessionInfo50;
  SessionInfo502 : PSessionInfo502Array;
  TotalEntries,EntriesReadNT: DWORD;
  EntriesRead,TotalAvial: Word;
  i:integer;
begin
  lvSessions.Items.Clear;

  if not IsNT(OS) then Close; //  

  if OS then begin  //  NT
    FLibHandle := LoadLibrary('NETAPI32.DLL');
    if FLibHandle = 0 then Exit;
    @NetSessionEnumNT := GetProcAddress(FLibHandle, 'NetSessionEnum');
    if not Assigned(NetSessionEnumNT) then
    begin
      FreeLibrary(FLibHandle);
      Exit;
    end;
    SessionInfo502 := nil;
    if NetSessionEnumNT(nil,nil,nil,502,@SessionInfo502,DWORD(-1),@entriesreadNT, @totalentries, nil)=0 then
    for i:=0 to EntriesReadNT-1 do
    begin
      with lvSessions.Items.Add do  //   
      begin
        Caption := string(SessionInfo502^[i].sesi502_cname); // 
        SubItems.Add(SessionInfo502^[i].sesi502_username);   // 
        SubItems.Add(IntToStr(SessionInfo502^[i].sesi502_num_opens)); // 
        SubItems.Add(CardinalToTimeStr(SessionInfo502^[i].Sesi502_Time)); // 
        SubItems.Add(CardinalToTimeStr(SessionInfo502^[i].sesi502_idle_time)); //  
      end;
    end;
  end else begin //  Windows 9x-Me
   FLibHandle := LoadLibrary('SVRAPI.DLL');
   if FLibHandle = 0 then Exit;
   @NetSessionEnum := GetProcAddress(FLibHandle, 'NetSessionEnum');
    if not Assigned(NetSessionEnum) then
    begin
      FreeLibrary(FLibHandle);
      Exit;
    end;
   if NetSessionEnum (nil,50,@SessionInfo50,SizeOf(SessionInfo50),@EntriesRead,@TotalAvial) = 0 then
   for i:=0 to EntriesRead-1 do
   begin
      with lvSessions.Items.Add do  //   
      begin
        Caption := string(SessionInfo50[i].Sesi50_cname); // 
        SubItems.Add(SessionInfo50[i].Sesi50_username);   // 
        SubItems.Add(IntToStr(SessionInfo50[i].sesi50_num_opens)); // 
        SubItems.Add(CardinalToTimeStr(SessionInfo50[i].Sesi50_Time)); // 
        SubItems.Add(CardinalToTimeStr(SessionInfo50[i].sesi50_idle_time)); //  
        SessionCloseKey[i]:= SessionInfo50[i].sesi50_key; //   
      end;
   end;
 end;
 FreeLibrary(FLibHandle);
end;

////////////////////////////////////////////////////////////////////////////////
//
//    
//

procedure TMainForm.suitempbtnCloseSessionClick(Sender: TObject);
var
  OS: Boolean;
  FLibHandle : THandle;
  CNameNT: PWideChar;
  CName9x: PAnsiChar;
  Key:SmallInt;
  i: Integer;
begin
  if not IsNT(OS) then Close; //  

  if not Assigned(lvSessions.Selected) then Exit;
  i:= lvSessions.Selected.Index; //   

  if OS then begin
    FLibHandle := LoadLibrary('NETAPI32.DLL');
    if FLibHandle = 0 then Exit;
    @NetSessionDelNT := GetProcAddress(FLibHandle, 'NetSessionDel');
    if not Assigned(NetSessionDelNT) then
    begin
      FreeLibrary(FLibHandle);
      Exit;
    end;
    //    
    CNameNT := PWChar(WideString('\\'+lvSessions.Items.Item[i].Caption));
    NetSessionDelNT(nil,CNameNT,nil);
  end else begin
    FLibHandle := LoadLibrary('SVRAPI.DLL');
    if FLibHandle = 0 then Exit;
    @NetSessionDel := GetProcAddress(FLibHandle, 'NetSessionDel');
    if not Assigned(NetSessionDel) then
    begin
      FreeLibrary(FLibHandle);
      Exit;
    end;
    //    
    CName9x := PAnsiChar(lvSessions.Items.Item[i].Caption);
    key := SessionCloseKey[i]; //   
    NetSessionDel(nil,CName9x,Key);
  end;
  FreeLibrary(FLibHandle);
end;

////////////////////////////////////////////////////////////////////////////////
//
//     
//

procedure TMainForm.suitempbtnGetFilesClick(Sender: TObject);
var
  OS: Boolean;
  FLibHandle : THandle;
  FileInfoNT: PFileInfo3Array;
  FileInfo9x: array [0..512] of TFileInfo50;
  TotalEntries,EntriesReadNT: DWORD;
  EntriesRead,TotalAvial: Word;
  i:integer;
begin
  lvfiles.Items.Clear;

  if not IsNT(OS) then Close; //  

  if OS then begin  //  NT
    FLibHandle := LoadLibrary('NETAPI32.DLL');
    if FLibHandle = 0 then Exit;
    @NetFileEnumNT := GetProcAddress(FLibHandle, 'NetFileEnum');
    if not Assigned(NetFileEnumNT) then
    begin
      FreeLibrary(FLibHandle);
      Exit;
    end;
    FileInfoNT := nil;
    if NetFileEnumNT(nil,nil,nil,3,@FileInfoNT,DWORD(-1),@entriesreadNT, @totalentries, nil)=0 then
    for i:=0 to EntriesReadNT-1 do
    begin
      with lvFiles.Items.Add do  //   
      begin
        Caption := string(IntToStr(FileInfoNT^[i].fi3_id)); //
        SubItems.Add(FileInfoNT^[i].fi3_pathname);   //  
        SubItems.Add(FileInfoNT^[i].fi3_username);   // 
      end;
    end;
  end else begin //  Windows 9x-Me
   FLibHandle := LoadLibrary('SVRAPI.DLL');
   if FLibHandle = 0 then Exit;
   @NetFileEnum := GetProcAddress(FLibHandle, 'NetFileEnum');
    if not Assigned(NetFileEnum) then
    begin
      FreeLibrary(FLibHandle);
      Exit;
    end;
   if NetFileEnum (nil, nil,50,@FileInfo9x,SizeOf(FileInfo9x),@EntriesRead,@TotalAvial)= 0 then
   for i:=0 to EntriesRead-1 do
   begin
      with lvFiles.Items.Add do  //   
      begin
        Caption := string(IntToStr(FileInfo9x[i].fi50_id)); //
        SubItems.Add(FileInfo9x[i].fi50_pathname); //  
        SubItems.Add(FileInfo9x[i].fi50_username); // 
      end;
   end;
 end;
 FreeLibrary(FLibHandle);
end;

////////////////////////////////////////////////////////////////////////////////
//
//   
//

procedure TMainForm.suitempbtnCloseFileClick(Sender: TObject);
var
  OS: Boolean;
  FLibHandle : THandle;
  i: Integer;
begin
  if not IsNT(OS) then Close; //  

  if not Assigned(lvFiles.Selected) then Exit;
  i:= lvFiles.Selected.Index; //   

  if OS then begin //  NT
    FLibHandle := LoadLibrary('NETAPI32.DLL');
    if FLibHandle = 0 then Exit;
    @NetFileClose := GetProcAddress(FLibHandle, 'NetFileClose');
    if not Assigned(NetFileClose) then
    begin
      FreeLibrary(FLibHandle);
      Close;
    end;
    NetFileClose(nil,StrToInt(lvFiles.Items.Item[i].Caption));// 
  end else begin //  Windows 9x-Me
    FLibHandle := LoadLibrary('SVRAPI.DLL');
    if FLibHandle = 0 then Exit;
    @NetFileClose2 := GetProcAddress(FLibHandle, 'NetFileClose2');
    if not Assigned(NetFileClose2) then
    begin
      FreeLibrary(FLibHandle);
      Close;
    end;
    NetFileClose2(nil,StrToInt(lvFiles.Items.Item[i].Caption));
  end;
  FreeLibrary(FLibHandle);
end;

////////////////////////////////////////////////////////////////////////////////
//
//    -  
//

procedure TMainForm.tmrTrafficTimer(Sender: TObject);
  //  ,     "" 
  //  ,       
  type TMAC = array [0..7] of Byte;
  //    ,  ,    
  function GetMAC(Value: TMAC; Length: DWORD): String;
  var
    i: Integer;
  begin
    if Length = 0 then Result := '00-00-00-00-00-00' else
    begin
      Result := '';
      for i:= 0 to Length -2 do
        Result := Result + IntToHex(Value[i],2)+'-';
      Result := Result + IntToHex(Value[Length-1],2);
    end;
  end;

// 
var
  FLibHandle : THandle;
  Table: TMibIfTable;
  i : integer;
  Size   : integer;
begin
if torefresh then
begin
btnGetShares.Click;
btnGetSessions.Click;
btnGetFiles.Click;
end;
  tmrTraffic.Enabled := false; //    
  lvTraffic.Items.BeginUpdate;
  lvTraffic.Items.Clear;  // 
  FLibHandle := LoadLibrary('IPHLPAPI.DLL'); // 
  if FLibHandle = 0 then Exit;
  @GetIfTable := GetProcAddress(FLibHandle, 'GetIfTable');
  if not Assigned(GetIfTable) then
  begin
    FreeLibrary(FLibHandle);
    Close;
  end;

  Size := SizeOf(Table);
  if GetIfTable(@Table, @Size, false ) = 0 then // 
    for i:= 0 to Table.dwNumEntries-1 do begin
      with lvTraffic.Items.Add do begin // 
        Caption := String(Table.Table[i].bDescr); // 
        SubItems.Add(GetMAC(TMAC(Table.Table[i].bPhysAddr),
          Table.Table[i].dwPhysAddrLen)); //MAC 
        SubItems.Add(IntToStr(Table.Table[i].dwInOctets)); //  
        SubItems.Add(IntToStr(Table.Table[i].dwOutOctets)); //  
      end;
    end;
  lvTraffic.Items.EndUpdate;
  FreeLibrary(FLibHandle);
  tmrTraffic.Enabled := true; //   
end;

procedure TMainForm.suitempButton1Click(Sender: TObject);
begin
torefresh:=true;
btnGetShares.Enabled:=false;
btnCloseShares.Enabled:=false;
btnAddShares.Enabled:=false;
btnCloseSession.Enabled:=false;
btnGetSessions.Enabled:=false;
btnGetFiles.Enabled:=false;
btnCloseFile.Enabled:=false;
button1.Enabled:=false;
button2.Enabled:=true;
end;

procedure TMainForm.suitempButton2Click(Sender: TObject);
begin
torefresh:=false;
btnGetShares.Enabled:=true;
btnCloseShares.Enabled:=true;
btnAddShares.Enabled:=true;
btnCloseSession.Enabled:=true;
btnGetSessions.Enabled:=true;
btnGetFiles.Enabled:=true;
btnCloseFile.Enabled:=true;
button2.Enabled:=false;
button1.Enabled:=true;
end;

procedure TMainForm.FormActivate(Sender: TObject);
begin
Button2.Click;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
application.Title:='SuperAdm Kill Watcher!';
end;

end.
